Unit Avz4r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure Avz4r(var A :Array of Real; N :Integer;
                var IP :Array of Integer);
implementation

procedure Avz4r(var A :Array of Real; N :Integer;
                var IP :Array of Integer);
var                
LA,I,M,J,K,IJ,IT,L,ITT :Integer;
T,TT,R :Real;
IU :Array [0..20] of Integer;
IL :Array [0..20] of Integer;
const
R1 :Real = 3.75E-01;
R2 :Real = 5.898437E-01;
R3 :Real = 3.90625E-02;
R4 :Real = 2.1875E-01;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
LA := N;
for I:=1 to LA do
 begin
  if ( A[I-1] < 0.0 ) 
   then A[I-1] := -A[I-1];
_1:
 end;
M := 1;
I := 1;
J := LA;
R := R1;
_2:
if ( I = J ) 
 then goto _10;
if ( R > R2 ) 
 then goto _3;
R := R+R3;
goto _4;
_3:
R := R-R4;
_4:
K := I;
IJ := Trunc( I+(J-I)*Int(R) );
T := A[IJ-1];
IT := IP[IJ-1];
if ( A[I-1] <= T ) 
 then goto _5;
A[IJ-1] := A[I-1];
A[I-1] := T;
T := A[IJ-1];
IP[IJ-1] := IP[I-1];
IP[I-1] := IT;
IT := IP[IJ-1];
_5:
L := J;
if ( A[J-1] >= T ) 
 then goto _7;
A[IJ-1] := A[J-1];
A[J-1] := T;
T := A[IJ-1];
IP[IJ-1] := IP[J-1];
IP[J-1] := IT;
IT := IP[IJ-1];
if ( A[I-1] <= T ) 
 then goto _7;
A[IJ-1] := A[I-1];
A[I-1] := T;
T := A[IJ-1];
IP[IJ-1] := IP[I-1];
IP[I-1] := IT;
IT := IP[IJ-1];
goto _7;
_6:
TT := A[L-1];
A[L-1] := A[K-1];
A[K-1] := TT;
ITT := IP[L-1];
IP[L-1] := IP[K-1];
IP[K-1] := ITT;
_7:
L := L-1;
if ( A[L-1] > T ) 
 then goto _7;
_8:
K := K+1;
if ( A[K-1] < T ) 
 then goto _8;
if ( K <= L ) 
 then goto _6;
if ( L-I <= J-K ) 
 then goto _9;
IL[M-1] := I;
IU[M-1] := L;
I := K;
M := M+1;
goto _11;
_9:
IL[M-1] := K;
IU[M-1] := J;
J := L;
M := M+1;
goto _11;
_10:
M := M-1;
if ( M = 0 ) 
 then goto _14;
I := IL[M-1];
J := IU[M-1];
_11:
if ( J-I >= 1 ) 
 then goto _4;
if ( I = 1 ) 
 then goto _2;
I := I-1;
_12:
I := I+1;
if ( I = J ) 
 then goto _10;
T := A[I+0];
IT := IP[I+0];
if ( A[I-1] <= T ) 
 then goto _12;
K := I;
_13:
A[K+0] := A[K-1];
IP[K+0] := IP[K-1];
K := K-1;
if ( T < A[K-1] ) 
 then goto _13;
A[K+0] := T;
IP[K+0] := IT;
goto _12;
_14:
end;

end.
